#pragma once

#include "CoreMinimal.h"
#include "Presenter.h"
#include "UObject/SoftObjectPtr.h"
#include "EOnboardingMenuState.h"
#include "OnboardingMenuPresenter.generated.h"

class UUserWidget;
class UOnboardingTutorialSubPresenter;
class UGameManualSubPresenter;
class USubPresenter;

UCLASS(Blueprintable, EditInlineNew)
class DBDUIPRESENTERS_API UOnboardingMenuPresenter : public UPresenter
{
	GENERATED_BODY()

public:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	TSoftClassPtr<UUserWidget> OnboardingMenuWidgetClass;

private:
	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	UOnboardingTutorialSubPresenter* _onboardingTutorialSubPresenter;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	UGameManualSubPresenter* _gameManualSubPresenter;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	USubPresenter* _activeSubPresenter;

private:
	UFUNCTION(BlueprintCallable)
	void OnSetUIEnabled(bool enabled);

	UFUNCTION(BlueprintCallable)
	void OnSettingsAction();

	UFUNCTION(BlueprintCallable)
	void OnQuitGameAction();

	UFUNCTION(BlueprintCallable)
	void OnMenuTabSelectedAgain(EOnboardingMenuState menuState);

	UFUNCTION(BlueprintCallable)
	void OnMenuTabSelected(EOnboardingMenuState menuState);

	UFUNCTION(BlueprintCallable)
	void OnFirstOnboardingStepsDone(bool isFirstStepsDone);

	UFUNCTION(BlueprintCallable)
	void OnChangeAccountAction();

	UFUNCTION(BlueprintCallable)
	void OnBackAction();

public:
	UOnboardingMenuPresenter();
};

FORCEINLINE uint32 GetTypeHash(const UOnboardingMenuPresenter) { return 0; }
